kbuild: rust_is_available: handle failures calling `$RUSTC`/`$BINDGEN`
[linux-2.6-block.git] / scripts / rust_is_available.sh
CommitLineData
78521f33
MO
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# Tests whether a suitable Rust toolchain is available.
78521f33
MO
5
6set -e
7
8min_tool_version=$(dirname $0)/min-tool-version.sh
9
10# Convert the version string x.y.z to a canonical up-to-7-digits form.
11#
12# Note that this function uses one more digit (compared to other
13# instances in other version scripts) to give a bit more space to
14# `rustc` since it will reach 1.100.0 in late 2026.
15get_canonical_version()
16{
17 IFS=.
18 set -- $1
19 echo $((100000 * $1 + 100 * $2 + $3))
20}
21
aac284b1
MO
22# Print a reference to the Quick Start guide in the documentation.
23print_docs_reference()
24{
25 echo >&2 "***"
26 echo >&2 "*** Please see Documentation/rust/quick-start.rst for details"
27 echo >&2 "*** on how to set up the Rust support."
28 echo >&2 "***"
29}
30
e90db552
MO
31# Print an explanation about the fact that the script is meant to be called from Kbuild.
32print_kbuild_explanation()
33{
34 echo >&2 "***"
35 echo >&2 "*** This script is intended to be called from Kbuild."
36 echo >&2 "*** Please use the 'rustavailable' target to call it instead."
37 echo >&2 "*** Otherwise, the results may not be meaningful."
38 exit 1
39}
40
aac284b1
MO
41# If the script fails for any reason, or if there was any warning, then
42# print a reference to the documentation on exit.
43warning=0
44trap 'if [ $? -ne 0 ] || [ $warning -ne 0 ]; then print_docs_reference; fi' EXIT
45
e90db552
MO
46# Check that the expected environment variables are set.
47if [ -z "${RUSTC+x}" ]; then
48 echo >&2 "***"
49 echo >&2 "*** Environment variable 'RUSTC' is not set."
50 print_kbuild_explanation
51fi
52
53if [ -z "${BINDGEN+x}" ]; then
54 echo >&2 "***"
55 echo >&2 "*** Environment variable 'BINDGEN' is not set."
56 print_kbuild_explanation
57fi
58
59if [ -z "${CC+x}" ]; then
60 echo >&2 "***"
61 echo >&2 "*** Environment variable 'CC' is not set."
62 print_kbuild_explanation
63fi
64
78521f33
MO
65# Check that the Rust compiler exists.
66if ! command -v "$RUSTC" >/dev/null; then
d824d2f9
MY
67 echo >&2 "***"
68 echo >&2 "*** Rust compiler '$RUSTC' could not be found."
69 echo >&2 "***"
78521f33
MO
70 exit 1
71fi
72
73# Check that the Rust bindings generator exists.
74if ! command -v "$BINDGEN" >/dev/null; then
d824d2f9
MY
75 echo >&2 "***"
76 echo >&2 "*** Rust bindings generator '$BINDGEN' could not be found."
77 echo >&2 "***"
78521f33
MO
78 exit 1
79fi
80
81# Check that the Rust compiler version is suitable.
82#
83# Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
f2955228
MO
84rust_compiler_output=$( \
85 LC_ALL=C "$RUSTC" --version 2>/dev/null
86) || rust_compiler_code=$?
87if [ -n "$rust_compiler_code" ]; then
88 echo >&2 "***"
89 echo >&2 "*** Running '$RUSTC' to check the Rust compiler version failed with"
90 echo >&2 "*** code $rust_compiler_code. See output and docs below for details:"
91 echo >&2 "***"
92 echo >&2 "$rust_compiler_output"
93 echo >&2 "***"
94 exit 1
95fi
78521f33 96rust_compiler_version=$( \
f2955228 97 echo "$rust_compiler_output" \
7cd6a3e1 98 | sed -nE '1s:.*rustc ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
78521f33
MO
99)
100rust_compiler_min_version=$($min_tool_version rustc)
101rust_compiler_cversion=$(get_canonical_version $rust_compiler_version)
102rust_compiler_min_cversion=$(get_canonical_version $rust_compiler_min_version)
103if [ "$rust_compiler_cversion" -lt "$rust_compiler_min_cversion" ]; then
d824d2f9
MY
104 echo >&2 "***"
105 echo >&2 "*** Rust compiler '$RUSTC' is too old."
106 echo >&2 "*** Your version: $rust_compiler_version"
107 echo >&2 "*** Minimum version: $rust_compiler_min_version"
108 echo >&2 "***"
78521f33
MO
109 exit 1
110fi
d824d2f9 111if [ "$rust_compiler_cversion" -gt "$rust_compiler_min_cversion" ]; then
78521f33
MO
112 echo >&2 "***"
113 echo >&2 "*** Rust compiler '$RUSTC' is too new. This may or may not work."
114 echo >&2 "*** Your version: $rust_compiler_version"
115 echo >&2 "*** Expected version: $rust_compiler_min_version"
116 echo >&2 "***"
aac284b1 117 warning=1
78521f33
MO
118fi
119
120# Check that the Rust bindings generator is suitable.
121#
122# Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
f2955228
MO
123rust_bindings_generator_output=$( \
124 LC_ALL=C "$BINDGEN" --version 2>/dev/null
125) || rust_bindings_generator_code=$?
126if [ -n "$rust_bindings_generator_code" ]; then
127 echo >&2 "***"
128 echo >&2 "*** Running '$BINDGEN' to check the Rust bindings generator version failed with"
129 echo >&2 "*** code $rust_bindings_generator_code. See output and docs below for details:"
130 echo >&2 "***"
131 echo >&2 "$rust_bindings_generator_output"
132 echo >&2 "***"
133 exit 1
134fi
78521f33 135rust_bindings_generator_version=$( \
f2955228 136 echo "$rust_bindings_generator_output" \
7cd6a3e1 137 | sed -nE '1s:.*bindgen ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
78521f33
MO
138)
139rust_bindings_generator_min_version=$($min_tool_version bindgen)
140rust_bindings_generator_cversion=$(get_canonical_version $rust_bindings_generator_version)
141rust_bindings_generator_min_cversion=$(get_canonical_version $rust_bindings_generator_min_version)
142if [ "$rust_bindings_generator_cversion" -lt "$rust_bindings_generator_min_cversion" ]; then
d824d2f9
MY
143 echo >&2 "***"
144 echo >&2 "*** Rust bindings generator '$BINDGEN' is too old."
145 echo >&2 "*** Your version: $rust_bindings_generator_version"
146 echo >&2 "*** Minimum version: $rust_bindings_generator_min_version"
147 echo >&2 "***"
78521f33
MO
148 exit 1
149fi
d824d2f9 150if [ "$rust_bindings_generator_cversion" -gt "$rust_bindings_generator_min_cversion" ]; then
78521f33
MO
151 echo >&2 "***"
152 echo >&2 "*** Rust bindings generator '$BINDGEN' is too new. This may or may not work."
153 echo >&2 "*** Your version: $rust_bindings_generator_version"
154 echo >&2 "*** Expected version: $rust_bindings_generator_min_version"
155 echo >&2 "***"
aac284b1 156 warning=1
78521f33
MO
157fi
158
159# Check that the `libclang` used by the Rust bindings generator is suitable.
52cae7f2
MO
160#
161# In order to do that, first invoke `bindgen` to get the `libclang` version
162# found by `bindgen`. This step may already fail if, for instance, `libclang`
163# is not found, thus inform the user in such a case.
164bindgen_libclang_output=$( \
165 LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null
166) || bindgen_libclang_code=$?
167if [ -n "$bindgen_libclang_code" ]; then
168 echo >&2 "***"
169 echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
170 echo >&2 "*** bindings generator) failed with code $bindgen_libclang_code. This may be caused by"
171 echo >&2 "*** a failure to locate libclang. See output and docs below for details:"
172 echo >&2 "***"
173 echo >&2 "$bindgen_libclang_output"
174 echo >&2 "***"
175 exit 1
176fi
177
178# `bindgen` returned successfully, thus use the output to check that the version
179# of the `libclang` found by the Rust bindings generator is suitable.
7cd6a3e1
MO
180#
181# Unlike other version checks, note that this one does not necessarily appear
182# in the first line of the output, thus no `sed` address is provided.
78521f33 183bindgen_libclang_version=$( \
52cae7f2 184 echo "$bindgen_libclang_output" \
9eb7e20e 185 | sed -nE 's:.*clang version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
78521f33
MO
186)
187bindgen_libclang_min_version=$($min_tool_version llvm)
188bindgen_libclang_cversion=$(get_canonical_version $bindgen_libclang_version)
189bindgen_libclang_min_cversion=$(get_canonical_version $bindgen_libclang_min_version)
190if [ "$bindgen_libclang_cversion" -lt "$bindgen_libclang_min_cversion" ]; then
d824d2f9
MY
191 echo >&2 "***"
192 echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN') is too old."
193 echo >&2 "*** Your version: $bindgen_libclang_version"
194 echo >&2 "*** Minimum version: $bindgen_libclang_min_version"
195 echo >&2 "***"
78521f33
MO
196 exit 1
197fi
198
199# If the C compiler is Clang, then we can also check whether its version
200# matches the `libclang` version used by the Rust bindings generator.
201#
202# In the future, we might be able to perform a full version check, see
203# https://github.com/rust-lang/rust-bindgen/issues/2138.
dee3a6b8 204cc_name=$($(dirname $0)/cc-version.sh $CC | cut -f1 -d' ')
d824d2f9
MY
205if [ "$cc_name" = Clang ]; then
206 clang_version=$( \
dee3a6b8 207 LC_ALL=C $CC --version 2>/dev/null \
d824d2f9
MY
208 | sed -nE '1s:.*version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
209 )
210 if [ "$clang_version" != "$bindgen_libclang_version" ]; then
211 echo >&2 "***"
212 echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN')"
213 echo >&2 "*** version does not match Clang's. This may be a problem."
214 echo >&2 "*** libclang version: $bindgen_libclang_version"
215 echo >&2 "*** Clang version: $clang_version"
216 echo >&2 "***"
aac284b1 217 warning=1
78521f33
MO
218 fi
219fi
220
221# Check that the source code for the `core` standard library exists.
222#
223# `$KRUSTFLAGS` is passed in case the user added `--sysroot`.
224rustc_sysroot=$("$RUSTC" $KRUSTFLAGS --print sysroot)
225rustc_src=${RUST_LIB_SRC:-"$rustc_sysroot/lib/rustlib/src/rust/library"}
226rustc_src_core="$rustc_src/core/src/lib.rs"
227if [ ! -e "$rustc_src_core" ]; then
d824d2f9
MY
228 echo >&2 "***"
229 echo >&2 "*** Source code for the 'core' standard library could not be found"
230 echo >&2 "*** at '$rustc_src_core'."
231 echo >&2 "***"
78521f33
MO
232 exit 1
233fi